export class Directive {
}
export class Ref extends Directive {
    constructor(propertyName) {
        super();
        this.propertyName = propertyName;
    }
}
export function html(strings, ...values) {
    let html = strings[0];
    const directives = [];
    for (let i = 0; i < values.length; ++i) {
        const arg = values[i];
        if (arg instanceof Directive) {
            directives.push(arg);
            if (arg instanceof Ref) {
                html += `id="${arg.propertyName}"`;
            }
            else {
                html += String(values[i]);
            }
        }
        else {
            throw new Error("Invalid Directive");
        }
        html += strings[i + 1];
    }
    return { html, directives };
}
export function ref(propertyName) {
    return new Ref(propertyName);
}
//# sourceMappingURL=html.js.map